<!doctype html>
<html lang="en" xmlns:th="http://www.thymeleaf.org">
<head>
    <base th:href="${#request.getContextPath() + '/'} ">
    <meta charset="utf-8">
    <meta name="renderer" content="webkit">
    <meta http-equiv="X-UA-Compatible" content="IE=edge,chrome=1">
    <meta name="viewport" content="width=device-width, initial-scale=1.0, minimum-scale=1.0, maximum-scale=1.0, question-scalable=0">
    <link rel="stylesheet" href="assets/fonts/font-awesome/css/font-awesome.css"/>
    <link rel="stylesheet" href="assets/layuiadmin/layui/css/layui.css" media="all">
    <link rel="stylesheet" href="assets/layuiadmin/style/admin.css" media="all">
</head>
<body>
<div class="layui-anim layui-anim-fadein">
    <div class="layui-row">
        <div class="layui-col-md12">
            <div class="layui-card">
                <div class="layui-card-body">
                    <div class="test-table-reload-btn" style="margin-bottom: 10px;">
                        <div class="layui-inline">
                            <input type="text" id="keywords" class="layui-input search-item search-item-width-100" placeholder="输入关键字">
                        </div>
                        <div class="layui-inline layui-form search-item">
                            <select id="type" name="type" lay-filter="typeFilter">
                                <option value="">选择类型</option>
                                <option value="choice">选择题</option>
                                <option value="tureOrFalse">判断题</option>
                                <option value="fillInTheBlanks">填空题</option>
                                <option value="answer">解答题</option>
                            </select>
                        </div>
                        <div id="choiceTypeBox" class="layui-inline layui-form search-item" style="display: none;">
                            <select id="choiceType" name="choiceType">
                                <option value="">选择类型</option>
                                <option value="single">单选</option>
                                <option value="multiple">多选</option>
                            </select>
                        </div>
                        <div class="layui-inline layui-form search-item">
                            <select id="difficulty" name="difficulty" lay-filter="difficultyFilter">
                                <option value="">选择难度</option>
                                <option value="1">⭐</option>
                                <option value="2">⭐⭐</option>
                                <option value="3">⭐⭐⭐</option>
                                <option value="4">⭐⭐⭐⭐</option>
                                <option value="5">⭐⭐⭐⭐⭐</option>
                            </select>
                        </div>
                        <div class="layui-inline">
                            <input type="hidden" id="questionType" readonly style="cursor: pointer;">
                            <input type="text" id="questionTypeName" class="layui-input search-item search-item-width-100" placeholder="自定义类型" readonly style="cursor: pointer;">
                        </div>
                        <button type="button" id="search" class="layui-btn layui-btn-sm">
                            <i class="fa fa-lg fa-search"></i> 搜索
                        </button>
                        <button type="button" id="confirm" class="layui-btn layui-btn-normal layui-btn-sm" style="float: right;">确定</button>
                    </div>
                    <table class="layui-hide" id="dataTable" lay-filter="dataTable"></table>
                </div>
            </div>
        </div>
    </div>
</div>
<script src="assets/layuiadmin/layui/layui.js"></script>
<script>
    layui.config({
        base: 'assets/layuiadmin/'
    }).extend({
        index: 'lib/index'
    }).use(['index', 'table', 'laydate', 'common'], function() {
        var $ = layui.$;
        var $win = $(window);
        var table = layui.table;
        var admin = layui.admin;
        var laydate = layui.laydate;
        var laytpl = layui.laytpl;
        var common = layui.common;
        var form = layui.form;
        var resizeTimeout = null;
        var classInfoId = top.restAjax.params(window.location.href).classInfoId;
        var tableUrl = 'api/question/listpageexcept/{classInfoId}';
        var oldSelectedQuestionList = top.dialog.dialogData.oldSelectedQuestionList ? top.dialog.dialogData.oldSelectedQuestionList : [];
        // 清空上次选择
        top.dialog.dialogData.newSelectedQuestionList = [];
        var newSelectedQuestionList = [];
        var tableData = [];

        // 初始化选择列表
        function initNewSelectedQuestionList() {
            for(var i = 0, item; item = oldSelectedQuestionList[i++];) {
                newSelectedQuestionList.push(item);
            }
        }
        initNewSelectedQuestionList();

        function getDifficulty(num) {
            var result = '';
            for(var i = 0; i < num; i++) {
                result += '⭐'
            }
            return result;
        }

        // 初始化表格
        function initTable() {
            $.extend(table, {config: {checkName: 'checked'}});
            table.render({
                elem: '#dataTable',
                id: 'dataTable',
                url: top.restAjax.path(tableUrl, [classInfoId]),
                width: admin.screen() > 1 ? '100%' : '',
                height: $win.height() - 60,
                limit: 20,
                limits: [20, 40, 60, 80, 100, 200],
                request: {
                    pageName: 'page',
                    limitName: 'rows'
                },
                cols: [
                    [
                        {type:'checkbox', fixed: 'left'},
                        {field:'rowNum', width:80, title: '序号', fixed: 'left', align:'center', templet: '<span>{{d.LAY_INDEX}}</span>'},
                        {field: 'subject', width: 400, title: '题目', align:'center',
                            templet: function(row) {
                                var rowData = row[this.field];
                                if(typeof(rowData) === 'undefined' || rowData == null || rowData == '') {
                                    return '-';
                                }
                                return rowData;
                            }
                        },
                        {field: 'questionTypeName', width: 140, title: '试题类型', align:'center',
                            templet: function(row) {
                                var rowData = row[this.field];
                                if(typeof(rowData) === 'undefined' || rowData == null || rowData == '') {
                                    return '-';
                                }
                                return rowData;
                            }
                        },
                        {field: 'questionTypeName', width: 140, title: '自定义试题类型', align:'center',
                            templet: function(row) {
                                var rowData = row[this.field];
                                if(typeof(rowData) === 'undefined' || rowData == null || rowData == '') {
                                    return '-';
                                }
                                return rowData;
                            }
                        },
                        {field: 'type', width: 150, title: '种类', align:'center',
                            templet: function(row) {
                                var rowData = row[this.field];
                                if(typeof(rowData) === 'undefined' || rowData == null || rowData == '') {
                                    return '-';
                                }
                                if(rowData == 'choice') {
                                    return '选择题';
                                } else if(rowData == 'tureOrFalse') {
                                    return '判断题';
                                } else if(rowData == 'fillInTheBlanks') {
                                    return '填空题';
                                } else if(rowData == 'answer') {
                                    return '解答题';
                                }
                                return rowData;
                            }
                        },
                        {field: 'choiceType', width: 100, title: '选择类别', align:'center',
                            templet: function(row) {
                                if(row.type != 'choice') {
                                    return '-';
                                }
                                var rowData = row[this.field];
                                if(typeof(rowData) === 'undefined' || rowData == null || rowData == '') {
                                    return '-';
                                }
                                if(rowData == 'single') {
                                    return '单选';
                                } else if(rowData == 'multiple') {
                                    return '多选';
                                }
                                return rowData;
                            }
                        },
                        {field: 'difficulty', width: 150, title: '难度', align:'center',
                            templet: function(row) {
                                var rowData = row[this.field];
                                if(typeof(rowData) === 'undefined' || rowData == null || rowData == '') {
                                    return '-';
                                }
                                return getDifficulty(rowData);
                            }
                        },
                        {field: 'source', width: 150, title: '来源', align:'center',
                            templet: function(row) {
                                var rowData = row[this.field];
                                if(typeof(rowData) === 'undefined' || rowData == null || rowData == '') {
                                    return '-';
                                }
                                return rowData;
                            }
                        },
                        {field: 'gmtCreate', width: 180, title: '添加时间', align:'center',
                            templet: function(row) {
                                var rowData = row[this.field];
                                if(typeof(rowData) === 'undefined' || rowData == null || rowData == '') {
                                    return '-';
                                }
                                return rowData;
                            }
                        },
                        {field: 'getQuestion', width: 100, title: '详情', fixed: 'right', align:'center', exportType: 'text',
                            templet: function(row) {
                                return '<button class="layui-btn layui-btn layui-btn-sm layui-btn-normal" lay-event="getQuestionEvent"><i class="fa fa-search"></i> 查看</button>';
                            }
                        },
                    ]
                ],
                page: true,
                parseData: function(data) {
                    for(var i = 0, item; item = data.rows[i++];) {
                        if(!newSelectedQuestionList) {
                            item.checked = false;
                            continue;
                        }
                        var isSelected = false;
                        for(var j = 0, jItem; jItem = newSelectedQuestionList[j++];) {
                            if(item.questionId === jItem.questionId) {
                                isSelected = true;
                                break;
                            }
                        }
                        if(isSelected) {
                            item.checked = true;
                        } else {
                            item.checked = false;
                        }
                    }
                    tableData = data.rows;

                    return {
                        'code': 0,
                        'msg': '',
                        'count': data.total,
                        'data': data.rows
                    };
                }
            });
        }
        // 重载表格
        function reloadTable(currentPage) {
            table.reload('dataTable', {
                url: top.restAjax.path(tableUrl, [classInfoId]),
                where: {
                    keywords: $('#keywords').val(),
                    startTime: $('#startTime').val(),
                    endTime: $('#endTime').val(),
                    type: $('#type').val(),
                    choiceType: $('#choiceType').val(),
                    questionType: $('#questionType').val(),
                    questionType: $('#questionType').val(),
                    difficulty: $('#difficulty').val()
                },
                page: {
                    curr: currentPage
                },
            });
        }
        initTable();
        function isQuestionSelected(questionId) {
            for(var i = 0, item; item = newSelectedQuestionList[i++];) {
                if(questionId == item.questionId) {
                    return true;
                }
            }
            return false;
        }

        function addQuestionSelected(questionItem) {
            if(isQuestionSelected(questionItem.questionId)) {
                return;
            }
            newSelectedQuestionList.push({
                questionId: questionItem.questionId,
            })
        }

        function removeQuestionSelected(questionItem) {
            for(var i = 0, item; item = newSelectedQuestionList[i++];) {
                if(questionItem.questionId == item.questionId) {
                    newSelectedQuestionList.splice(--i, 1);
                    i--;
                    return;
                }
            }
        }

        table.on('checkbox(dataTable)', function(obj) {
            if(obj.type === 'all') {
                if(obj.checked) {
                    // 添加全部
                    for(var i = 0, item; item = tableData[i++];) {
                        addQuestionSelected(item);
                    }
                } else {
                    // 删除全部
                    for(var i = 0, item; item = tableData[i++];) {
                        removeQuestionSelected(item);
                    }
                }
            } else {
                if(obj.checked) {
                    addQuestionSelected(obj.data);
                } else {
                    removeQuestionSelected(obj.data);
                }
            }
        });

        table.on('radio(dataTable)', function(obj) {
            newSelectedQuestionList.splice(0, newSelectedQuestionList.length);
            addQuestionSelected(obj.data);
        });
        $(document).on('click', '#search', function() {
            reloadTable(1);
        });
        $(document).on('click', '#confirm', function() {
            top.dialog.dialogData.newSelectedQuestionList = newSelectedQuestionList;
            top.dialog.closeBox();
        });

        table.on('tool(dataTable)', function(obj) {
            var data = obj.data;
            var event = obj.event;
            if(event === 'getQuestionEvent') {
                top.dialog.open({
                    url: top.restAjax.path('route/question/get-question.html?questionId={questionId}', [data.questionId]),
                    title: '查看试题，难度：' + getDifficulty(data.difficulty),
                    width: '500px',
                    height: '80%',
                    onClose: function() {
                    }
                });
            }
        });

        form.on('select(typeFilter)', function(data){
            $('#choiceType').val('')
            form.render('select');
            if(data.value === 'choice') {
                $('#choiceTypeBox').show();
            } else {
                $('#choiceTypeBox').hide();
            }
        });

        $('#questionTypeName').on('click', function() {
            top.dialog.open({
                url: top.restAjax.path('route/questiontype/list-tree-select.html?questionTypeIds={questionTypeIds}', [$('#questionType').val()]),
                title: '选择自定义类型',
                width: '200px',
                height: '400px',
                onClose: function() {
                    var selectedNodes = top.dialog.dialogData.selectedNodes;
                    if(selectedNodes.length > 0) {
                        var questionType = '';
                        var questionTypeName = '';
                        for(var i = 0, item; item = selectedNodes[i++];) {
                            if(questionType.length > 0) {
                                questionType += ',';
                                questionTypeName += ',';
                            }
                            questionType += item.id;
                            questionTypeName += item.name;
                        }
                        $('#questionType').val(questionType);
                        $('#questionTypeName').val(questionTypeName);
                    } else {
                        $('#questionType').val('');
                        $('#questionTypeName').val('');
                    }
                }
            });
        })
    });
</script>
</body>
</html>